# osh
# Copyright (C) 2005 Jack Orenstein <jao@geophile.com>
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

"""Usage: outobj

Write the pickled form of input objects to stdout.
"""
    
import pickle
import sys

import osh.oshobjects

def outobj():
    return _Outobj()

class _Outobj(osh.oshobjects.Op):

    # state

    _output = None
    

    # OshCommand interface
    
    def doc(self):
        return __doc__

    def setup(self):
        self._output = pickle.Pickler(sys.stdout)
        

    # Receiver interface
    
    def receive(self, object):
        self._output.dump(object)
